{*******************************************************}
{                                                       }
{         Delphi eXpert Extensions   (X)                }
{                                                       }
{         Copyright (c) 1997 Alexander Buzaev           }
{         FidoNet 2:5020/880.11@fidonet.org             }
{                                                       }
{         Method Navigator Tester                       }
{                                                       }
{*******************************************************}

unit MNavFm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, MNavExp, ComCtrls, RichEdit, EditIntf, EditUtil;

type
  TMNavForm = class(TForm)
    PopupMenu1: TPopupMenu;
    MethodNavigator1: TMenuItem;
    StatusBar: TStatusBar;
    Editor: TRichEdit;
    procedure MethodNavigator1Click(Sender: TObject);
    procedure EditorSelectionChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
    procedure UpdateCursorPos;
  end;

var
  MNavForm: TMNavForm;

implementation

{$R *.DFM}

procedure TMNavForm.MethodNavigator1Click(Sender: TObject);
begin
  ExecuteMNav;
end;

procedure TMNavForm.UpdateCursorPos;
var
  CharPos: TPoint;
Begin
  CharPos.Y := SendMessage(Editor.Handle, EM_EXLINEFROMCHAR, 0,
    Editor.SelStart);
  CharPos.X := (Editor.SelStart -
    SendMessage(Editor.Handle, EM_LINEINDEX, CharPos.Y, 0));
  Inc(CharPos.Y);
  Inc(CharPos.X);
  StatusBar.Panels[0].Text := Format('Line: %3d   Col: %3d', [CharPos.Y, CharPos.X]);
End;

procedure TMNavForm.EditorSelectionChange(Sender: TObject);
begin
  UpdateCursorPos;
end;

procedure TMNavForm.FormShow(Sender: TObject);
begin
  UpdateCursorPos;
end;

end.
