unit xLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, rxHook;

type
  TAlignControl = (acNone, acTop, acLeft);
  TxLabel = class(TLabel)
  private
    FAlignControl: TAlignControl;
    FNewWndProc: Pointer;
    FPrevWndProc: Pointer;
    procedure UpdateBounds;
    procedure WMMove(var Message: TWMMove); message WM_MOVE;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure SetFocusControl(Value: TWinControl);
  protected
    procedure SetAlignControl(Value: TAlignControl);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property FocusControl write SetFocusControl;
    property AlignControl: TAlignControl read FAlignControl write SetAlignControl;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('X', [TxLabel]);
end;

constructor TxLabel.Create(AOwner: TComponent);
var
  P: Pointer;
Begin
  inherited;
  FAlignControl:=acNone;
{  FNewWndProc := MakeObjectInstance(HookWndProc);
  FPrevWndProc := nil;
  FControl.HandleNeeded;
  P := Pointer(GetWindowLong(FControl.Handle, GWL_WNDPROC));
  if (P <> FNewWndProc) then begin
    FPrevWndProc := P;
    SetWindowLong(FControl.Handle, GWL_WNDPROC, LongInt(FNewWndProc));
  end;}
End;

destructor TxLabel.Destroy;
Begin
  FreeObjectInstance(FNewWndProc);
  FNewWndProc := nil;
  inherited;
End;

procedure TxLabel.SetAlignControl(Value: TAlignControl);
Begin
  IF FAlignControl<>Value Then
  begin
    FAlignControl:=Value;
    UpdateBounds;
  end;
End;

procedure TxLabel.WMSize(var Message: TWMSize);
begin
  inherited;
  UpdateBounds;
end;

procedure TxLabel.WMMove(var Message: TWMMove);
begin
  inherited;
  UpdateBounds;
end;

procedure TxLabel.SetFocusControl(Value: TWinControl);
Begin
{  IF Value<>FocusControl Then
  begin
    inherited FocusControl:=Value;
    Hook.WinControl:=FocusControl;
  end;  }
End;

procedure TxLabel.UpdateBounds;
Begin
  IF Assigned(FocusControl) Then
  Case FAlignControl OF
    acTop:
    begin
      Top:=FocusControl.Top-Height;
      Left:=FocusControl.Left;
    end;
  End;
End;

{procedure TxLabel.HookAfterMessage(Sender: TObject; var Msg: TMessage;
  var Handled: Boolean);
Begin
  IF (Msg.Msg=WM_MOVE) or (Msg.Msg=WM_SIZE) Then
    UpdateBounds;
  IF (csDesigning in ComponentState) Then
    Beep;
//  and (Msg.Msg=WM_COMMAND)Then
//    UpdateBounds;
End;
}
END.
